package com.codigoparallevar.minicards.bridge.blocks;

import com.codigoparallevar.minicards.types.functional.Consumer;
import com.programaker.bridge.ProgramakerBridgeConfigurationBlock;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class BridgeBlockListBuilder {
    private final LinkedList<ProgramakerBridgeConfigurationBlock> blockList;

    public BridgeBlockListBuilder() {
        this.blockList = new LinkedList<>();
    }


    public List<ProgramakerBridgeConfigurationBlock> Build() {
        return blockList;
    }

    public BridgeBlockListBuilder addOperation(String id, String message,
                                               List<BlockArgumentDefinition> arguments,
                                               Consumer<List<? extends Object>> operation) {
        return this.addOperation(new OperationBlockDefinition(id, message, arguments, operation));
    }

    private BridgeBlockListBuilder addOperation(ProgramakerBridgeConfigurationBlock block) {
        this.blockList.add(block);

        return this;
    }
}
